/*******************************************************************************
* mgn.h                                                                        *
* header for the definition of genlib functions, and macros                    *
* author  : Frederic Petrot                                                    *
* version : 3.18                                                               *
* date    : 03/09/93                                                           *
* version : 3.26                                                               *
* date    : 10/06/97                                                           *
*******************************************************************************/
/* Types for the ptype lists as required in version 3.26
   As the types are all exclusives from another there is no need for
   styled values. */

/*******************************************************************************
* physical placement functions                                                 *
*******************************************************************************/
extern void genDEF_PHFIG();
extern void genLOAD_PHFIG();
extern void genSAVE_PHFIG();
extern void genDEF_AB();
extern void genDEF_PHINS();
extern ptype_list *genPHCON();
extern ptype_list *genCOPY_UP_CON();
extern ptype_list *genCOPY_UP_CON_FACE();
extern ptype_list *genCOPY_UP_ALL_CON();
extern ptype_list *genPHSEG();
extern ptype_list *genCOPY_UP_SEG();
extern ptype_list *genTHRU_H();
extern ptype_list *genTHRU_V();
extern ptype_list *genTHRU_CON_H();
extern ptype_list *genTHRU_CON_V();
extern ptype_list *genWIRE1();
extern ptype_list *genWIRE2();
extern ptype_list *genWIRE3();
extern ptype_list *genPHVIA();
extern void genPLACE();
extern void genPLACE_RIGHT();
extern void genPLACE_TOP();
extern void genPLACE_LEFT();
extern void genPLACE_BOTTOM();
extern void genPLACE_REF();
extern void genPLACE_ON();
extern ptype_list *genPHREF();
extern ptype_list *genCOPY_UP_REF();
extern ptype_list *genCOPY_UP_ALL_REF();
extern ptype_list *genPLACE_VIA_REF();
extern ptype_list *genPLACE_CON_REF();
extern ptype_list *genPLACE_SEG_REF();
extern void genFLATTEN_PHFIG();
extern void genFLATTEN_ALL_PHINS();
extern long genGET_REF_X();
extern long genGET_REF_Y();
extern long genGET_CON_X();
extern long genGET_CON_Y();
extern long genGET_INS_X();
extern long genGET_INS_Y();
extern long genHEIGHT();
extern long genWIDTH();
extern void genREVERSE_PHCON();
extern void genOUTLINE();
/*******************************************************************************
* netlist description functions                                                *
*******************************************************************************/
extern void genDEF_LOFIG();
extern void genLOAD_LOFIG();
extern void genSAVE_LOFIG();
extern void genLOINS();
extern void genLOINSE();
extern void genLOTRS();
extern void genLOCON();
extern void genLOSIGMERGE();
extern void genFLATTEN_LOFIG();
extern void genFLATTEN_ALL_LOINS();
extern void genDEF_PHSC();
extern void genSAVE_PHSC();
extern void genSC_PLACE();
extern void genSC_RIGHT();
extern void genSC_LEFT();
extern void genSC_TOP();
extern void genSC_BOTTOM();
extern void genSC_CHANNEL();
extern void genSC_CON_CHANNEL();
/*******************************************************************************
* name forming functions, for both views                                       *
*******************************************************************************/
extern char *genBUS();
extern char *genELM();
extern char *genNAME();

/*******************************************************************************
* macro definitions for allowed stdlib functions                               *
*******************************************************************************/
#define PRINTF       printf
#define STRLEN(a)    (long)(a == NULL ? 0 : strlen(a))

/*******************************************************************************
* macro definitions in order to allows float and integer typed parameters      *
*******************************************************************************/
#define DEF_PHFIG(name)                      genDEF_PHFIG(name)
#define LOAD_PHFIG(name)                     genLOAD_PHFIG(name)
#define SAVE_PHFIG                           genSAVE_PHFIG
#define DEF_AB(dx1,dy1,dx2,dy2) \
            genDEF_AB((long)((dx1)*SCALE_X),(long)((dy1)*SCALE_X), \
                        (long)((dx2)*SCALE_X),(long)((dy2)*SCALE_X))
#define DEF_PHINS(name) \
            genDEF_PHINS(name)
#define PHCON(layer,width,name,orient,x,y) \
            genPHCON(layer,(long)((width)*SCALE_X),name,orient, \
                     (long)((x)*SCALE_X),(long)((y)*SCALE_X))
#define COPY_UP_CON(index,locname,insname,newname) \
            genCOPY_UP_CON(index,locname,insname,newname)
#define COPY_UP_ALL_CON(orient,insname,cheminom) \
            genCOPY_UP_ALL_CON(orient,insname,cheminom)
#define COPY_UP_CON_FACE(orient,locname,insname,newname) \
            genCOPY_UP_CON_FACE(orient,locname,insname,newname)
#define PHSEG(layer,width,name,x1,y1,x2,y2) \
            genPHSEG(layer,(long)((width)*SCALE_X),name,(long)((x1)*SCALE_X), \
                     (long)((y1)*SCALE_X), (long)((x2)*SCALE_X), \
                     (long)((y2)*SCALE_X))
#define COPY_UP_SEG(locname,insname,newname) \
            genCOPY_UP_SEG(locname,insname,newname)
#define WIRE1(layer,width,ins1,con1,index1,ins2,con2,index2) \
            genWIRE1(layer,(long)((width)*SCALE_X),ins1,con1,index1,ins2, \
                     con2,index2)
#define WIRE2(layer,width,ins1,con1,index1,ins2,con2,index2,x,y) \
            genWIRE2(layer,(long)((width)*SCALE_X),ins1,con1,index1,ins2, \
                     con2,index2, (long)((x)*SCALE_X),(long)((y)*SCALE_X))
#define WIRE3(layer,width,ins1,con1,index1,ins2,con2,index2,x1,y1,x2,y2)  \
            genWIRE3(layer,(long)((width)*SCALE_X),ins1,con1,index1,ins2, \
                     con2,index2, (long)((x1)*SCALE_X),(long)((y1)*SCALE_X), \
                     (long)((x2)*SCALE_X),(long)((y2)*SCALE_X))
#define PHVIA(type,x,y) \
            genPHVIA(type,(long)((x)*SCALE_X),(long)((y)*SCALE_X))
#define PLACE(figname,insname,sym,x,y) \
            genPLACE(figname,insname,sym,(long)((x)*SCALE_X),(long)((y)*SCALE_X))
#define PLACE_RIGHT(figname,insname,sym)  genPLACE_RIGHT(figname,insname,sym)
#define PLACE_TOP(figname,insname,sym)    genPLACE_TOP(figname,insname,sym)
#define PLACE_LEFT(figname,insname,sym)   genPLACE_LEFT(figname,insname,sym)
#define PLACE_BOTTOM(figname,insname,sym) genPLACE_BOTTOM(figname,insname,sym)
#define PLACE_REF(figname,insname,sym,insref,refname) \
            genPLACE_REF(figname,insname,sym,insref,refname)
#define PLACE_ON(figname,insname1,con1,index1,sym,insname2,con2,index2) \
            genPLACE_ON(figname,insname1,con1,index1,sym,\
                     insname2,con2,index2)
#define THRU_H(layer,width,y) \
            genTHRU_H(layer,(long)((width)*SCALE_X),(long)((y)*SCALE_X))
#define THRU_V(layer,width,x) \
            genTHRU_V(layer,(long)((width)*SCALE_X),(long)((x)*SCALE_X))
#define THRU_CON_H(layer,width,name,y) \
            genTHRU_CON_H(layer,(long)((width)*SCALE_X),name,(long)((y)*SCALE_X))
#define THRU_CON_V(layer,width,name,x) \
            genTHRU_CON_V(layer,(long)((width)*SCALE_X),name,(long)((x)*SCALE_X))
#define PHREF(type,name,x,y) \
            genPHREF(type,name,(long)((x)*SCALE_X),(long)((y)*SCALE_X))
#define COPY_UP_REF(refname,insname,newname) \
            genCOPY_UP_REF(refname,insname,newname)
#define COPY_UP_ALL_REF(reftype,insname,cheminom) \
            genCOPY_UP_ALL_REF(reftype,insname,cheminom)
#define PLACE_VIA_REF(insname,refname,type) \
            genPLACE_VIA_REF(insname,refname,type)
#define PLACE_CON_REF(insname,refname,conname,layer,width,face) \
            genPLACE_CON_REF(insname,refname,conname,layer,\
                           (long)((width)*SCALE_X),face)
#define PLACE_SEG_REF(insname,refname,layer,width,face) \
            genPLACE_SEG_REF(insname,refname,layer,(long)((width)*SCALE_X),face)
#define GET_REF_X(insname,refname) \
            ((genGET_REF_X(insname,refname)/SCALE_X))
#define GET_REF_Y(insname,refname) \
            ((genGET_REF_Y(insname,refname)/SCALE_X))
#define GET_INS_X(insname)                ((genGET_INS_X(insname)/SCALE_X))
#define GET_INS_Y(insname)                ((genGET_INS_Y(insname)/SCALE_X))
#define GET_CON_X(insname,conname,index) \
            ((genGET_CON_X(insname,conname,index)/SCALE_X))
#define GET_CON_Y(insname,conname,index) \
            ((genGET_CON_Y(insname,conname,index)/SCALE_X))
#define HEIGHT(cellName)                  ((genHEIGHT(cellName)/SCALE_X))
#define WIDTH(cellName)                   ((genWIDTH(cellName)/SCALE_X))
#define FLATTEN_PHFIG(insname,concat)     genFLATTEN_PHFIG(insname,concat)
#define FLATTEN_ALL_PHINS(concat, catal)  genFLATTEN_ALL_PHINS(concat, catal)
#define REVERSE_PHCON(conname)            genREVERSE_PHCON(conname)
#define OUTLINE                           genOUTLINE

#define DEF_LOFIG(name)                   genDEF_LOFIG(name)
#define LOAD_LOFIG(name)                  genLOAD_LOFIG(name)
#define SAVE_LOFIG                        genSAVE_LOFIG
#define LOSIG(name)                       genLOSIG(name)
#define LOINS                             genLOINS
#define LOINSE                            genLOINSE
#define LOTRS(type,width,length,grid,source,drain) \
            genLOTRS(type,(long)((width)*SCALE_X), \
                     (long)((length)*SCALE_X),grid,source,drain)
#define LOCON(conname,direction,signame)  genLOCON(conname,direction,signame)
#define LOSIGMERGE(signame1, signame2)    genLOSIGMERGE(signame1, signame2)
#define FLATTEN_LOFIG(insname,concat)     genFLATTEN_LOFIG(insname,concat)
#define FLATTEN_ALL_LOINS(concat, catal)  genFLATTEN_ALL_LOINS(concat, catal)
#define UNFLATTEN_LOFIG                   genUNFLATTEN_LOFIG

#define USED(s, c)								genUSED(s, c)

#define DEF_PHSC(name)                    genDEF_PHSC(name)
#define SAVE_PHSC                         genSAVE_PHSC
#define SC_PLACE(insname,sym,x,y) \
            genSC_PLACE(insname,sym,(long)((x)*SCALE_X),(long)((y)*SCALE_X))
#define SC_RIGHT(insname,sym)             genSC_RIGHT(insname,sym)
#define SC_LEFT(insname,sym)              genSC_LEFT(insname,sym)
#define SC_TOP(insname,sym)               genSC_TOP(insname,sym)
#define SC_BOTTOM(insname,sym)            genSC_BOTTOM(insname,sym)
#define SC_CHANNEL(direction,width,insname) \
            genSC_CHANNEL(direction,(long)((width)*SCALE_X),insname)
#define SC_CON_CHANNEL(conname,orient,layer,width,insname) \
            genSC_CON_CHANNEL(conname,orient,layer,\
                              (long)((width)*SCALE_X),insname)

#define BUS(signame,from,to)              genBUS(signame,from,to)
#define ELM(signame,number)               genELM(signame,number)
#define NAME                              genNAME
