#ifndef TEL
#define TEL

#define TEL_CON  332123
#define TEL_TMP  332124
#define TEL_CAPA 332125

typedef struct elmway
{
  struct elmway		*NEXT;
  struct elmcon		*N1;
  struct elmcon		*N2;
  float			 RESI;
  float			 ED12;
  float			 ED21;
} elmway_list;

typedef struct elmcon
{
  struct elmcon		*NEXT;
  struct elmout		*OUTWAY;
  long			 INDEX;
  chain_list		*WAY;
  struct elmcon		*LINK;
  struct elmpaq		*PAQ;
} elmcon_list;

typedef struct elmout
{
  struct elmout		*NEXT;
  struct elmway		*WAY;
  float			 R12;
  float			 R21;
} elmout_list;

typedef struct elmview
{
  struct elmview	*NEXT;		/* pour allocation par tas */
  chain_list 		*LOCON;
  struct elmpaq		*PAQ;
} elmview_list;

typedef struct elmpaq
{
  struct elmcon		*CON;
  struct elmway		*WAY;
  float			 CAPA;
  struct elmpaq		*NEXT;
  struct elmpaq		*LINK;
  long			 INDEX;
} elmpaq_list;


typedef struct selmoredata
{
  float		RESI;
  float		DIRECTE;
  float		INVERSE;
} elmoredata;

/* File tel_elmview.c */

extern elmview_list* buildelmoreview() ;
extern void buildpaqrecmarq() ;
extern void buildpaqrec() ;
extern elmway_list* getelmway() ;
extern elmview_list* mergeelmview() ;
extern void delelmview() ;
extern void calcoutway() ;
extern int calcwayinterf() ;
extern chain_list* getcrossway() ;
extern void  cpyoldpaqtonewpaq() ;
extern float getcaparec() ;
extern chain_list* getloconelm() ;
extern elmway_list* heapelmway() ;
extern void freeelmway() ;
extern elmcon_list* heapelmcon() ;
extern void freeelmcon() ;
extern elmout_list* heapelmout() ;
extern void freeelmout() ;
extern elmview_list* heapelmview() ;
extern void freeelmview() ;
extern elmpaq_list* heapelmpaq() ;
extern void freeelmpaq() ;
extern elmway_list* giveelmway() ;
extern elmview_list* getnewelmview() ;
extern elmpaq_list* getnewelmpaq() ;
extern elmpaq_list* getelmpaq() ;
extern elmcon_list* getelmcon() ;
extern elmout_list* addelmout() ;
extern elmway_list* addelmway() ;
extern void setloconelm() ;
extern elmcon_list* addelmcon() ;
extern void dispelmstat() ;
extern void addelmconcapa() ;
extern int delelmconcapa() ;
extern float getelmconcapa() ;
extern float getelmnodecapa() ;

/* File tel_elmchk.c */

extern void chkelmview() ;
extern void dispelmview() ;

/*******************************************************************************
Fonction de calcul des delais d'Elmore.
*******************************************************************************/

/*
fourni la capacit totale du rseau sur le noeud n1, sauf sur la branche wire.
float getavalcapa(ptrcnet,n1,wire);
*/

extern float		getavalcapa();

/*
renvoie le dlai d'Elmore du noeud n1 au noeud n2, l'metteur ayant une
rsistance R et le rcepteur une capacit C.
float getelmore(ptrcnet,n1,n2,R,C);
Si le dlai ne peut tre calcul, la valeur -1.0 est retourne.
*/

extern float		getelmore();

/*
idem que getelmore, renvoye le dlai d'Elmore dans le sens DIRECTE, mais aussi
dans le sens INVERSE, ainsi que la rsistance totale sur le chemin. Le pointeur
renvoy est statique. 
elmoredata*	getelmoredata(lorcnet_list *ptrcnet,long org,long dest,float Remet,float Crecep,chain_list *chemin);
*/

extern elmoredata*	getelmoredata();

/*
Fournie dans une liste chaine les wires pour aller du noeud org vers le noeud
dest. Le champs prec doit tre mis  la valeur NULL (il indique sur quelle
branche il ne faut pas chercher le chemin. En cas d'echec, cette fonction 
retourne la valeur NULL.
chain_list*	getway();
*/

extern chain_list*	getway();

#endif
