/*******************************************************************************
*                                                                              *
*  rcx headers. Hierarchical TAS.                                              *
*  By Greg, May 96.                                                            *
*  Laboratoire MASI.                                                           *
*                                                                              *
*******************************************************************************/

#ifndef TRC
#define TRC

typedef struct value
{
  struct value	*NEXT;
  locon_list	*ORG;
  locon_list	*DEST;
  int		 POSORG;
  int		 POSDEST;
  float		 VAL;
} value_list;

typedef struct rcx
{
  struct rcx	*NEXT;
  unsigned int	 FLAG;
  void		*VIEW;
  locon_list	*RCXEXTERNAL;
  chain_list	*RCXINTERNAL;
  value_list	*RCXTIME;
} rcx_list;

typedef struct sloconparam
{
  struct sloconparam	*NEXT;
  float			 RESI;
  float			 CAPA;
} loconparam;



#define MODELRCN   ((long)0)
#define MODELELM   ((long)1)
#define SAVESIG    ((long)2)
#define RCXERROR   ((long)3)

#define RCXMAX     ((long)1)
#define RCXMIN     ((long)2)
#define RCXTWO     ((long)3)
#define RCXALL     ((long)4)

/*************************************** FLAG **********************************

usage gnral

  b0  1: rc view
  b1  1: elmore view
  b2  1: le signal n'est pas complet, il doit etre sauvegarde dans la 
         hierarchie superieure.
  b3  1: une erreur (par exemple une boucle dans la vue ELM) rend le
         calcul des temps impossible.

*******************************************************************************/

#define SETFLAG(m,b) (m = m | (1<<b))
#define CLEARFLAG(m,b) (m = m &(~(1<<b)))
#define GETFLAG(m,b) (m & (1<<b))

#define RCXFILEEXTENTION "rcx"
#define PTYPERCX ((long)1664)
#define RCXNAME  ((long)1665)
#define LOCONPRM ((long)1666)
#define PARSE_ERROR  10
#define DRIVE_ERROR  11
#define MEMORY_ERROR 12
#define DATA_ERROR   13

extern void buildrcx();
extern void buildrcxtime();
extern void setrcxmodel();
extern void getrcxdelay() ;
extern void outrcxview();
extern void getrcxview();
extern void loadmodelfile();
extern void addloconrcxname();
extern char* getloconrcxname();
extern void addloconparam();
extern loconparam* getloconparam();
extern rcx_list* getrcx();
extern int delrcx() ;
extern void freevalue() ;
extern int delloconparam() ;

#endif
